"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.optionsPropType = exports.meta = exports.input = exports.formGroup = exports.childrenPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var optionsPropType = _propTypes["default"].arrayOf(_propTypes["default"].shape({
  label: _propTypes["default"].node.isRequired,
  value: _propTypes["default"].any
}));

exports.optionsPropType = optionsPropType;

var meta = _propTypes["default"].shape({
  active: _propTypes["default"].bool,
  dirty: _propTypes["default"].bool,
  dirtySinceLastSubmit: _propTypes["default"].bool,
  error: _propTypes["default"].any,
  initial: _propTypes["default"].any,
  invalid: _propTypes["default"].bool,
  modified: _propTypes["default"].bool,
  pristine: _propTypes["default"].bool,
  submitError: _propTypes["default"].any,
  submitFailed: _propTypes["default"].bool,
  submitSucceeded: _propTypes["default"].bool,
  submitting: _propTypes["default"].bool,
  touched: _propTypes["default"].bool,
  valid: _propTypes["default"].bool,
  validating: _propTypes["default"].bool,
  visited: _propTypes["default"].bool
});

exports.meta = meta;
var formGroup = {
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  meta: meta,
  description: _propTypes["default"].node
};
exports.formGroup = formGroup;

var input = _propTypes["default"].shape({
  name: _propTypes["default"].string.isRequired,
  value: _propTypes["default"].any
});

exports.input = input;

var childrenPropTypes = _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].arrayOf(_propTypes["default"].node)]);

exports.childrenPropTypes = childrenPropTypes;